package Quest::Tool;

use strict;
use lib qw(quest/lib);
use quest_const;

##########################
#### ݒ荀 ####
##########################

my $sos2_name = 'sos2.cgi'; # sos2{̂̃t@CifBNgpX͊܂߂Ȃj

##########################
#### ܂Őݒ荀 ####
##########################

my $separator_eol = Quest::SEPARATOR_EOL;
my $separator_pair = Quest::SEPARATOR_PAIR;
my $type_flag_scalar = Quest::TYPE_FLAG_SCALAR;
my $type_flag_array = Quest::TYPE_FLAG_ARRAY;
my $type_flag_hash = Quest::TYPE_FLAG_HASH;
my $type_flag_random = Quest::TYPE_FLAG_RANDOM;
my %prefix_hash = (
	&Quest::TYPE_PREFIX_SCALAR() => 1,
	&Quest::TYPE_PREFIX_ARRAY() => 1,
	&Quest::TYPE_PREFIX_HASH() => 1,
);
my %typeNameHash = (
	$type_flag_scalar => 'XJ[',
	$type_flag_array => 'z',
	$type_flag_hash => 'nbV',
	$type_flag_random => '_I',
);
my $typeHashRef = Quest::REF_HASH_CONFIG_TYPE;

my $currentFile = '';
-f "./${sos2_name}" or &error(sprintf('JgfBNgsos2{́i%sjȂ', $sos2_name));
my @paramList = @ARGV;
@paramList >= 1 or &usage();
require &Quest::PUBLIC_LIB_FILE();
require &Quest::PRIVATE_LIB_FILE();
my $mode = shift(@paramList);
if($mode eq '-create'){
	&create_mode(@paramList);
}
elsif($mode eq '-probab2thresh'){
	&probab2thresh_mode(@paramList);
}
elsif($mode eq '-thresh2probab'){
	&thresh2probab_mode(@paramList);
}
elsif($mode eq '-random'){
	&random_mode(@paramList);
}
else{
	&usage();
}

sub usage{
	&error(
		sprintf(
<<USAGE
gF perl quest_tool.pl̃pX [h p[^
    yݒt@C쐬z
        [hF -create
        p[^F vOC `t@C1̃pX [`t@C2̃pX...]
    ym臒lɕϊz
        [hF -probab2thresh
        p[^F i1001000Ȃǁj m1ix/j [m2ix/j...]
    y臒lmɕϊz
        [hF -thresh2probab
        p[^F i1001000Ȃǁj 臒l1 [臒l2...]
    y_ĨV~[gz
        [hF -random
        p[^F
            s m%s [m%s...]
                ܂
            s 臒l%s [臒l%s...]
⑫
    sos2.cgifBNgŎsB
    quest_const.pmtȂĎsꍇ́u-Iquest/libv̂悤-IIvVquest_const.pmfBNgw肷B
USAGE
			,
			Quest::RANDOM_PROBAB_SUFFIX,
			Quest::RANDOM_PROBAB_SUFFIX,
			Quest::RANDOM_THRESH_SUFFIX,
			Quest::RANDOM_THRESH_SUFFIX
		)
	);
}

sub create_mode{
	@_ >= 2 or &usage();
	my $pluginName = shift;
	my @patternList = @_;

	my $pluginTypeHashRef = &Quest::call_plugin($pluginName, Quest::PLUGIN_SUB_TYPE, []);
	foreach my $pattern (@patternList){
		$currentFile = '';
		my @fileList = grep {-f $_} glob($pattern);
		@fileList or &error(sprintf('p^[Ƀ}b`t@C݂ȂF p^[=%s', $pattern));
		foreach my $file (@fileList){
			$currentFile = $file;
			open(FILE, '<', $file) or &error('ǂݍ݂Ɏs');
			my @dataList = <FILE>;
			close(FILE);
			my %hash = ();
			foreach my $index (0 .. $#dataList){
				my $data = $dataList[$index];
				$data =~ s/[\r\n]+$//o;
				next if($data =~ /^\s*(?:#|$)/o);
				my ($key, $value) = split(/\Q${separator_pair}\E/o, $data, 2);
				not exists($hash{$key}) or &error(sprintf('L[dF s=%dAL[=%s', $index + 1, $key));
				defined($value) or &error(sprintf('l`F s=%dAL[=%s', $index + 1, $key));
				my $prefix = substr($value, 0, 1);
				exists($prefix_hash{$prefix}) or &error(sprintf('f[^^CvsF s=%dAL[=%sAf[^^Cv=%s', $index + 1, $key, $prefix));
				my $deserializeRef = &Quest::deserialize_data($data, sprintf('s=%d', $index + 1));
				keys(%$deserializeRef) == 1 or &error(sprintf('f[^ľ`sF s=%dAL[=%sAf[^^Cv=%s', $index + 1, $key, $prefix));
				exists($deserializeRef->{$key}) or &error(sprintf('f[^̃fVACYɎsF s=%dAL[=%sAf[^^Cv=%s', $index + 1, $key, $prefix));
				$hash{$key} = $deserializeRef->{$key};
			}
			my $serializeData = &Quest::serialize_data(\%hash);
			my $hashRef = &Quest::deserialize_data($serializeData, 'fVACY');
			my %keyHash = map {($_, 1)} keys(%$hashRef);
			foreach my $listRef (['{', $typeHashRef], ['vOC', $pluginTypeHashRef]){
				my $name = $listRef->[0];
				my $typeRef = $listRef->[1];
				while(my ($typeKey, $typeFlag) = each(%$typeRef)){
					exists($hashRef->{$typeKey}) or &error(sprintf('%sL[`F L[=%s', $name, $typeKey));
					if(&Quest::is_arrayref($hashRef->{$typeKey})){
						&has_array_type_flag($typeFlag) or &has_random_type_flag($typeFlag) or &error(sprintf('%sL[l̃^CvsF L[=%sA^Cv=%sAv^Cv=%s', $name, $typeKey, $typeNameHash{$type_flag_array}, &want_type($typeFlag)));
					}
					elsif(&Quest::is_hashref($hashRef->{$typeKey})){
						&has_hash_type_flag($typeFlag) or &has_random_type_flag($typeFlag) or &error(sprintf('%sL[l̃^CvsF L[=%sA^Cv=%sAv^Cv=%s', $name, $typeKey, $typeNameHash{$type_flag_hash}, &want_type($typeFlag)));
					}
					else{
						&has_scalar_type_flag($typeFlag) or &error(sprintf('%sL[l̃^CvsF L[=%sA^Cv=%sAv^Cv=%s', $name, $typeKey, $typeNameHash{$type_flag_scalar}, &want_type($typeFlag)));
					}
					delete($keyHash{$typeKey});
				}
			}
			not %keyHash or &error(sprintf('L[]F L[=%s', join('A', keys(%keyHash))));
			# NIl̃`FbN
			&error(sprintf('%sL[lmwł͈͎wł܂B', Quest::QUEST_KEY_THRESH)) unless(&Quest::is_probab_str($hashRef->{&Quest::QUEST_KEY_THRESH()}) || &Quest::is_thresh_str($hashRef->{&Quest::QUEST_KEY_THRESH()}));
			# _Ĩ`FbN
			foreach(\%$typeHashRef, \%$pluginTypeHashRef){
				while(my ($name, $flag) = each(%$_)){
					next unless(&has_random_type_flag($flag));
					&Quest::get_random_elem($hashRef->{$name}, $name . 'L[lԈĂ邽߃_IɎs܂B');
				}
			}
			# Vݒ̃`FbN
			my $prize = &Quest::get_prize($hashRef);
			my @prizeList;
			if(&Quest::is_hashref($prize)){
				@prizeList = keys(%$prize);
			}
			elsif(&Quest::is_arrayref($prize)){
				@prizeList = @$prize;
			}
			else{
				&error('Vݒ肪nbV^Cvłz^Cvł܂B');
			}
			&Quest::get_prize_name_list(
				{
					&Quest::QUEST_KEY_KIND() => $pluginName,
					&Quest::QUEST_KEY_RANK() => &Quest::get_rank($hashRef),
					&Quest::QUEST_KEY_PRIZE() => \@prizeList,
				}
			);
			print $serializeData, $separator_eol, "\n";
			$currentFile = '';
		}
	}
}

sub probab2thresh_mode{
	@_ >= 2 or &usage();
	my $fraction = int(shift);
	my @probabList = @_;

	&error('1̕w肳܂B') if($fraction < 1);
	@probabList = sort {$a <=> $b} map {int($_)} @probabList;
	&error('0̊mw肳܂B') if($probabList[0] < 0);
	my $probabCount = 0;
	foreach my $probab (@probabList){
		$probabCount += $probab;
		&error('w肳ꂽm̍v' . $fraction . '𒴂Ă܂B') if($probabCount > $fraction);
	}
	if($probabCount < $fraction){
		push(@probabList, $fraction - $probabCount);
		@probabList = sort {$a <=> $b} map {$_} @probabList;
		&info('m̍vw肳ꂽ' . $fraction . 'ł邽ߊm' . ($fraction - $probabCount) . 'ǉ܂B');
	}
	my %probabHash = ();
	foreach(@probabList){
		$probabHash{$_}++;
	}
	my $num;
	my $currentRate = -1;
	my $prevRate = 0;
	my @threshList = ();
	foreach my $index (0 .. $#probabList){
		next if($probabList[$index] == $currentRate);
		$currentRate = $probabList[$index];
		$num = 0;
		foreach my $key (keys(%probabHash)){
			$num += $probabHash{$key} if($key >= $currentRate);
		}
		$num = ($currentRate - $prevRate) * $num;
		foreach($index .. $#probabList){
			$threshList[$_] += $num;
		}
		$prevRate = $currentRate;
	}
	my %threshCountHash = ();
	foreach(@threshList){
		$threshCountHash{$_}++;
	}
	my $thresh;
	my $format = '%' . length($probabList[$#probabList]) . 'd/%d: %' . length($threshList[$#threshList]) . "d\n";
	foreach my $index (0 .. $#probabList){
		$thresh = $threshList[$#probabList - $index];
		printf($format, $probabList[$#probabList - $index], $fraction, $thresh);
	}
}

sub thresh2probab_mode{
	@_ >= 2 or &usage();
	my $fraction = int(shift);
	my @threshList = @_;

	&error('1̕w肳܂B') if($fraction < 1);
	@threshList = sort {$a <=> $b} map {int($_)} @threshList;
	&error('0臒lw肳܂B') if($threshList[0] < 0);
	&error('1ȏ臒lw肳Ă܂B') if($threshList[$#threshList] < 1);
	my $num;
	my $currentThresh = -1;
	my $prevThresh = 0;
	my @countList = ();
	foreach my $index (0 .. $#threshList){
		next if($threshList[$index] == $currentThresh);
		$currentThresh = $threshList[$index];
		$num = ($currentThresh - $prevThresh) / (@threshList - $index);
		foreach($index .. $#threshList){
			$countList[$_] += $num;
		}
		$prevThresh = $currentThresh;
	}
	my $total = 0;
	foreach(@countList){
		$total += $_;
	}
	my $probab;
	my $totalRate = 0;
	my $maxRate = 0;
	my @probabList = ();
	foreach(@countList){
		$probab = &ceil($_ * $fraction / $total);
		push(@probabList, $probab);
		$totalRate += $probab;
		$maxRate = $probab if($probab > $maxRate);
	}
	my %countHash = ();
	my $format = '%' . length($threshList[$#threshList]) . 'd: %' . length($maxRate) . "d/%d\n";
	my $thresh;
	foreach my $index (0 .. $#threshList){
		$thresh = $threshList[$#threshList - $index];
		printf($format, $thresh, $probabList[$#threshList - $index], $fraction);
	}
	&info('_ȉ؂グ̂ߊm̍vw肳ꂽ' . $fraction . '𒴂' . $totalRate . 'ɂȂ܂B') if($totalRate > $fraction);
}

sub random_mode{
	@_ >= 2 or &usage();
	my $tryNum = int(shift);
	my @randomList = @_;

	&error('1̎s񐔂w肳܂B') if($tryNum < 1);
	my %randomCountHash = ();
	foreach(@randomList){
		$randomCountHash{$_}++;
	}
	my $randomKey;
	my $maxThreshLen = 0;
	my $len;
	my %randomHash = ();
	my %countHash = ();
	foreach my $random (@randomList){
		$randomKey = $random . ($randomCountHash{$random} > 1 ? ('_' . ++$countHash{$random}) : '');
		$randomHash{$randomKey} = $random;
		$len = length($random);
		$maxThreshLen = $len if($len > $maxThreshLen);
	}
	%countHash = ();
	my $maxCountLen = 0;
	for(my $i = 0; $i < $tryNum; $i++){
		$randomKey = &Quest::get_random_elem(\%randomHash, '_ĨV~[g');
		$countHash{$randomKey}++;
		$len = length($countHash{$randomKey});
		$maxCountLen = $len if($len > $maxCountLen);
	}
	my $format = '%' . $maxThreshLen . 's: %' . $maxCountLen . "d\n";
	foreach $randomKey (sort {$b <=> $a or $a cmp $b} keys(%randomHash)){
		printf($format, $randomHash{$randomKey}, int($countHash{$randomKey}));
	}
}

sub ceil{
	my $num = shift;

	return $num == int($num) ? int($num) : int($num) + 1;
}

sub want_type{
	my $flag = shift;

	my @list = ();
	push(@list, $typeNameHash{$type_flag_scalar}) if(&has_scalar_type_flag($flag));
	push(@list, $typeNameHash{$type_flag_array}) if(&has_array_type_flag($flag));
	push(@list, $typeNameHash{$type_flag_hash}) if(&has_hash_type_flag($flag));
	push(@list, $typeNameHash{$type_flag_random}) if(&has_random_type_flag($flag));
	return join(',', @list);
}

sub has_scalar_type_flag{
	my $flag = shift;

	return ($flag & $type_flag_scalar) == $type_flag_scalar;
}

sub has_array_type_flag{
	my $flag = shift;

	return ($flag & $type_flag_array) == $type_flag_array;
}

sub has_hash_type_flag{
	my $flag = shift;

	return ($flag & $type_flag_hash) == $type_flag_hash;
}

sub has_random_type_flag{
	my $flag = shift;

	return ($flag & $type_flag_random) == $type_flag_random;
}

sub error{
	my $msg = shift;

	&main::error($msg);
}

sub info{
	my $msg = shift;
	print STDERR 'F ', $msg, "\n";
}

sub get_current_file{
	return $currentFile;
}

package main;

sub error{
	my $msg = shift;

	my $file = &Quest::Tool::get_current_file();
	print STDERR sprintf("#### %sG[ ####\n%s", $file ne '' ? sprintf('`t@Ci%sj', $file) : '', $msg), "\n";
	exit(1);
}
